import org.openJpeg.OpenJPEGJavaEncoder;
import org.openJpeg.OpenJPEGJavaEncoder.IJavaJ2KEncoderLogger;

public class Main implements IJavaJ2KEncoderLogger
{
    public static final String LIBRARY_PATH = 
        "/Users/callan/code/openjpeg-trunk/applications/JavaOpenJPEG/libJavaOpenJPEG.so";

    public void test()
    {
        OpenJPEGJavaEncoder encoder = new OpenJPEGJavaEncoder(LIBRARY_PATH);
        encoder.addLogger(this);
        long t0 = System.currentTimeMillis();
        // The nbResolutions, nbLayers and if needed the float[] psnrLayers or
        // ratioLayers must also be filled before calling this method.
        encoder.setDepth(8);
        encoder.setWidth(256);
        encoder.setHeight(256);
        encoder.setNbResolutions(1);
        //encoder.setPsnrLayers(new float[] { -1.0f });  // Lossless (-1.0)
        encoder.setRatioLayers(new float[] { 0.0f });  // Lossless (0.0)
        encoder.setImage8(new byte[256 * 256]);
        encoder.encodeImageToJ2K();
        System.err.println("Encode time: " + (System.currentTimeMillis() - t0));
        byte[] stream = encoder.getCompressedStream();
        System.err.println("Stream length: " + stream.length);
        System.err.println("Library stated stream length: " + encoder.getCompressedStreamLength());
    }

    public static void main(String[] args)
    {
        Main main = new Main();
        main.test();
    }

    /* (non-Javadoc)
     * @see org.openJpeg.OpenJPEGJavaEncoder.IJavaJ2KEncoderLogger#logEncoderError(java.lang.String)
     */
    public void logEncoderError(String message)
    {
        System.err.println(message);
    }

    /* (non-Javadoc)
     * @see org.openJpeg.OpenJPEGJavaEncoder.IJavaJ2KEncoderLogger#logEncoderMessage(java.lang.String)
     */
    public void logEncoderMessage(String message)
    {
        System.err.println(message);
    }

}
